import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

public class ChoiceController {
	private DrawingFrame bT;

	public ChoiceController(DrawingFrame jF) {
		LocalColorChoiceHandler lcch = new LocalColorChoiceHandler();
		Choice colorList = new Choice();
		colorList.add("black");
		colorList.add("red");
		colorList.add("green");
		colorList.add("blue");
		colorList.addItemListener(lcch);
		jF.getChoicePanel().add(colorList);

		LocalFillChoiceHandler lfch = new LocalFillChoiceHandler();
		Choice fillList = new Choice();
		fillList.add("empty");
		fillList.add("fill");
		fillList.addItemListener(lfch);
		jF.getChoicePanel().add(fillList);

		bT = jF;
	}

	private class LocalColorChoiceHandler implements ItemListener {
		public void itemStateChanged(ItemEvent arg0) {
			Object[] chosen = arg0.getItemSelectable().getSelectedObjects();
			for (Object o : chosen) {
				if (o.equals("black")) {
					bT.setCurrentColor(Color.BLACK);
				}
				else if (o.equals("red")) {
					bT.setCurrentColor(Color.RED);
				}
				else if (o.equals("green")) {
					bT.setCurrentColor(Color.GREEN);
				}
				else if (o.equals("blue")) {
					bT.setCurrentColor(Color.BLUE);
				}
			}
		}
	}

	private class LocalFillChoiceHandler implements ItemListener {
		public void itemStateChanged(ItemEvent arg0) {
			Object[] chosen = arg0.getItemSelectable().getSelectedObjects();
			for (Object o : chosen) {
				if (o.equals("empty")) {
					bT.setFillState(false);
				}
				else if (o.equals("fill")) {
					bT.setFillState(true);
				}
			}
		}
	}
}