import javax.swing.*;
import java.awt.*;


public abstract class Shape extends JComponent implements Cloneable {

	protected Point p1, p2;
	protected Color color;
	protected boolean fill;

	static final int LINE = 0;
	static final int CIRCLE = 1;
	static final int RECT = 2;

	public Shape(Point a1, Point a2) {
		p1 = a1;
		p2 = a2;
		color = Color.BLACK;
		fill = false;
	}

	public Shape(Point a1, Point a2, Color c) {
		p1 = a1;
		p2 = a2;
		color = c;
		fill = false;
	}

	public boolean equals(Shape shape) {
		return p1.equals(shape.p1) && p2.equals(shape.p2);
	}

	@Override
	abstract public Object clone();

	public Color getColor() {
		return color;
	}

	public void setColor(Color c) {
		color = c;
	}

	public void setFill(boolean b) {
		fill = b;
	}

	public void paint(Graphics g, int s) {
		// Not used
	}

	@Override
	public Dimension getPreferredSize() {
		return new Dimension((int) Math.abs(p1.getX() - p2.getX()), (int) Math.abs(p1.getY() - p2.getY()));
	}

	@Override
	public Dimension getMinimumSize() {
		return new Dimension((int) Math.abs(p1.getX() - p2.getX()), (int) Math.abs(p1.getY() - p2.getY()));
	}

	@Override
	public Dimension getMaximumSize() {
		return new Dimension((int) Math.abs(p1.getX() - p2.getX()), (int) Math.abs(p1.getY() - p2.getY()));
	}

	public void setSecondPoint(Point a2) { p2 = a2; }
}